
!CompiledMethod methodsFor: '*OmniST-KernelExtensions-accessing' stamp: 'StefanMarr 11/3/2011 15:55'!
methodNode
	"Return the parse tree that represents self"
	| aClass source |
	aClass := self methodClass.
	source := self
				getSourceFor: (self selector ifNil: [self defaultSelector])
				in: aClass.
	^(aClass parserClass new
		encoderClass: (aClass parserClass encoderClassFor: self);
		parse: source class: aClass)
			sourceText: source;
			yourself! !

!Parser class methodsFor: '*OmniST-KernelExtensions-encoder' stamp: 'StefanMarr 11/3/2011 21:40'!
encoderClassFor: aCompiledMethod
	^ aCompiledMethod isBlueBookCompiled
		ifTrue:  [EncoderForV3]
		ifFalse: [EncoderForV3PlusClosures]! !

!Behavior methodsFor: '*OmniST-KernelExtensions-instance creation' stamp: 'StefanMarr 11/6/2011 14:44'!
basicNew
	"This is the omni-fied implementation.
	 The original basicNew is now rawBasicNew."
	| obj |
	obj := self rawBasicNew.
	
	OProxyDomain initializeDomainForNewObject: obj of: self.
	
	^ obj! !

!Behavior methodsFor: '*OmniST-KernelExtensions-instance creation' stamp: 'StefanMarr 11/6/2011 14:43'!
basicNew: sizeRequested 
	"This is the omni-fied implementation.
	 The original basicNew: is now rawBasicNew:."
	| obj |
	obj := self rawBasicNew: sizeRequested.
	
	OProxyDomain initializeDomainForNewObject: obj of: self.
	
	^ obj! !

!Behavior methodsFor: '*OmniST-KernelExtensions-accessing' stamp: 'StefanMarr 11/5/2011 22:01'!
parserClass
	"Answer a parser class to use for parsing method headers."
	^ (OProxyDomain classHasDomainField: self)
		ifTrue:  [ParserForOmniProxyExperiment]
		ifFalse: [self compilerClass parserClass]! !

!Behavior methodsFor: '*OmniST-KernelExtensions-instance creation' stamp: 'StefanMarr 11/6/2011 14:31'!
rawBasicNew
	"Primitive. Answer an instance of the receiver (which is a class) with no 
	indexable variables. Fail if the class is indexable. Essential. See Object 
	documentation whatIsAPrimitive."

	<primitive: 70>
	self isVariable ifTrue: [ ^ self basicNew: 0 ].
	"space must be low"
	OutOfMemory signal.
	^ self basicNew  "retry if user proceeds"
! !

!Behavior methodsFor: '*OmniST-KernelExtensions-instance creation' stamp: 'StefanMarr 11/6/2011 14:37'!
rawBasicNew: sizeRequested 
	"Primitive. Answer an instance of this class with the number
	of indexable variables specified by the argument, sizeRequested.
	Fail if this class is not indexable or if the argument is not a
	positive Integer, or if there is not enough memory available. 
	Essential. See Object documentation whatIsAPrimitive."

	<primitive: 71>
	self isVariable ifFalse:
		[self error: self printString, ' cannot have variable sized instances'].
	(sizeRequested isInteger and: [sizeRequested >= 0]) ifTrue:
		["arg okay; space must be low."
		OutOfMemory signal.
		^ self basicNew: sizeRequested  "retry if user proceeds"].
	self primitiveFailed! !

!BytecodeEncoder methodsFor: '*OmniST-KernelExtensions-bytecode generation' stamp: 'StefanMarr 11/3/2011 14:20'!
adjustParseStackForPushInstVar: parseStack
	^ parseStack! !

!InstanceVariableNode methodsFor: '*OmniST-KernelExtensions-code generation' stamp: 'StefanMarr 11/3/2011 14:20'!
emitCodeForValue: stack encoder: encoder
	stack push: 1.
	encoder adjustParseStackForPushInstVar: stack.
	^encoder genPushInstVar: index! !

!LiteralNode methodsFor: '*OmniST-KernelExtensions' stamp: 'StefanMarr 10/31/2011 13:57'!
index
	^ index! !
